## activiz.net 1.0~git20111123

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.3 FATAL_ERROR)
PROJECT(ActiVizDotNet)


# Determine if we're building ActiVizDotNet (AVDN) as a "top level" project.
#
SET(AVDN_BUILD_IS_TOP_LEVEL 0)
IF("${ActiVizDotNet_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  SET(AVDN_BUILD_IS_TOP_LEVEL 1)
ENDIF("${ActiVizDotNet_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

IF(AVDN_BUILD_IS_TOP_LEVEL)
  IF(NOT LIBRARY_OUTPUT_PATH)
    SET(LIBRARY_OUTPUT_PATH ${ActiVizDotNet_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
  ENDIF(NOT LIBRARY_OUTPUT_PATH)
  IF(NOT EXECUTABLE_OUTPUT_PATH)
    SET(EXECUTABLE_OUTPUT_PATH ${ActiVizDotNet_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
  ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
ENDIF(AVDN_BUILD_IS_TOP_LEVEL)


# Make it clear that ActiViz is now open source: set the edition to
# "OpenSource" - the Commercial Edition is no longer for sale, but the
# OpenSource Edition is equivalent to it functionally. The Personal Edition
# restrictions are nowhere to be found... :-)
#
SET(AVDN_EDITION "OpenSource")
SET(AVDN_EDITION_SUFFIX "-OS")


# List of MSVC dlls for our INSTALL rules below:
#
SET(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP 1)
  # because we need the list and we'll add the INSTALL rule conditionally below...

#SET(CMAKE_INSTALL_DEBUG_LIBRARIES 1)
  # uncomment if you need to make a debug install/package...

INCLUDE(InstallRequiredSystemLibraries)


# Mummy:
#
FIND_PACKAGE(Mummy REQUIRED)
IF(NOT Mummy_BASE_DIR)
  MESSAGE(FATAL_ERROR "error: Mummy_BASE_DIR not defined. Please set Mummy_DIR to the directory containing MummyConfig.cmake")
ENDIF(NOT Mummy_BASE_DIR)


#MESSAGE(STATUS "<mummy>")
FOREACH(v
  Mummy_BASE_DIR
  Mummy_BIN_DIR
  Mummy_CMAKE_BUILD_TYPE
  Mummy_CMAKE_CONFIGURATION_TYPES
  Mummy_CONFIG_DIR
  Mummy_CONFIG_DIR_SUFFIX
  Mummy_CONFIG_FILE
  Mummy_CONFIGURATION_TYPE
  Mummy_DIR
  mummy_EXECUTABLE
  Mummy_INCLUDE_DIRS
  Mummy_LIB_DIR
  Mummy_SELECTED_CONFIGURATION
  Mummy_VERSION_MAJOR
  Mummy_VERSION_MINOR
  Mummy_VERSION_PATCH
  Mummy_VERSION_STRING
  )
  #MESSAGE(STATUS "${v}='${${v}}'")
ENDFOREACH(v)
#MESSAGE(STATUS "</mummy>")


# Macros to make building C# libs and exes easy:
#
INCLUDE("${Mummy_DIR}/MummyCMakeMacros.cmake")


# Set CSC_DEBUG_FLAG prior to including FindCsharp.cmake if we want
# to force C# debugging info... If it's set, it's honored. If it's
# not defined, then FindCsharp.cmake uses its own logic to choose
# a reasonable default for CSC_DEBUG_FLAG.
#
IF(DEFINED BUILDNAME)
  # Likely built via a script, default debug setting is OFF:
  SET(AVDN_BUILD_CSHARP_DEBUG_DEFAULT OFF)
ELSE(DEFINED BUILDNAME)
  # Likely built by a real live developer, default debug setting is ON:
  SET(AVDN_BUILD_CSHARP_DEBUG_DEFAULT ON)
ENDIF(DEFINED BUILDNAME)

OPTION(AVDN_BUILD_CSHARP_DEBUG
  "Build C# components with '/debug' command line flag"
  ${AVDN_BUILD_CSHARP_DEBUG_DEFAULT}
)

IF(AVDN_BUILD_CSHARP_DEBUG)
  SET(CSC_DEBUG_FLAG "/debug")
ENDIF(AVDN_BUILD_CSHARP_DEBUG)


# Tools locations - either already found by parent project, specified on the
# command line, or available in the PATH... If not, you'll have to find
# these things yourself at configure time... :-)
#
INCLUDE("${Mummy_DIR}/FindCsharp.cmake")

IF(NOT csc_EXECUTABLE)
  FIND_PROGRAM(csc_EXECUTABLE csc)
ENDIF(NOT csc_EXECUTABLE)
IF(NOT csc_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: C# compiler not found. csc_EXECUTABLE='${csc_EXECUTABLE}'")
ENDIF(NOT csc_EXECUTABLE)

IF(NOT mummy_EXECUTABLE)
  FIND_PROGRAM(mummy_EXECUTABLE mummy)
ENDIF(NOT mummy_EXECUTABLE)
IF(NOT mummy_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: mummy not found. mummy_EXECUTABLE='${mummy_EXECUTABLE}'")
ENDIF(NOT mummy_EXECUTABLE)

IF(NOT gccxml_EXECUTABLE)
  FIND_PROGRAM(gccxml_EXECUTABLE gccxml)
ENDIF(NOT gccxml_EXECUTABLE)
IF(NOT gccxml_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: gccxml not found. gccxml_EXECUTABLE='${gccxml_EXECUTABLE}'")
ENDIF(NOT gccxml_EXECUTABLE)


INCLUDE_DIRECTORIES(${Mummy_INCLUDE_DIRS})


# VTK:
#
FIND_PACKAGE(VTK)
IF(NOT VTK_USE_FILE)
  MESSAGE(FATAL_ERROR "error: VTK_USE_FILE not defined. Please set VTK_DIR to a compatible VTK build/binary tree...")
ENDIF(NOT VTK_USE_FILE)
INCLUDE(${VTK_USE_FILE})


# Read VTK_SOURCE_DIR value from "${VTK_DIR}/CMakeCache.txt" (assumes that
# VTK_DIR points to a build tree of VTK where the source directory is also
# still valid/in-sync -- does not work with an install tree of VTK...)
# Save the value in our own variable, AVDN_VTK_SOURCE_DIR.
#
# We need this value to access the @AVDN_VTK_SOURCE_DIR@/Wrapping/hints file
# which is referenced by MummySettings.xml.
#
# We also need it down in the Testing subdirectory to access *.tcl
# scripts so they can be converted to C# equivalents.
#
# We also pull out the values of the following VTK cache variables for our
# own information:
#   VTK_DATA_ROOT
#   VTK_USE_PARALLEL
#   VTK_USE_SYSTEM_EXPAT
#   VTK_USE_SYSTEM_FREETYPE
#   VTK_USE_SYSTEM_JPEG
#   VTK_USE_SYSTEM_LIBPROJ4
#   VTK_USE_SYSTEM_LIBXML2
#   VTK_USE_SYSTEM_PNG
#   VTK_USE_SYSTEM_TIFF
#   VTK_USE_SYSTEM_ZLIB
#
FILE(READ "${VTK_DIR}/CMakeCache.txt" AVDN_vtk_cmakecache)
STRING(REGEX REPLACE ";" "\\\\;" AVDN_vtk_cmakecache "${AVDN_vtk_cmakecache}")
STRING(REGEX REPLACE "\n" "E;" AVDN_vtk_cmakecache "${AVDN_vtk_cmakecache}")
SET(AVDN_VTK_SOURCE_DIR "")

FOREACH(line ${AVDN_vtk_cmakecache})
 IF(NOT line MATCHES "-ADVANCED:INTERNAL=")

  IF(line MATCHES "^VTK_SOURCE_DIR.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_SOURCE_DIR.*=(.*)E$" "\\1" AVDN_VTK_SOURCE_DIR "${line}")
  ENDIF(line MATCHES "^VTK_SOURCE_DIR.*=(.*)E$")

  IF(line MATCHES "^VTK_DATA_ROOT.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_DATA_ROOT.*=(.*)E$" "\\1" AVDN_VTK_DATA_ROOT "${line}")
  ENDIF(line MATCHES "^VTK_DATA_ROOT.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_PARALLEL.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_PARALLEL.*=(.*)E$" "\\1" AVDN_VTK_USE_PARALLEL "${line}")
  ENDIF(line MATCHES "^VTK_USE_PARALLEL.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_EXPAT.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_EXPAT.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_EXPAT "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_EXPAT.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_FREETYPE.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_FREETYPE.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_FREETYPE "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_FREETYPE.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_JPEG.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_JPEG.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_JPEG "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_JPEG.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_LIBPROJ4.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_LIBPROJ4.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_LIBPROJ4 "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_LIBPROJ4.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_LIBXML2.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_LIBXML2.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_LIBXML2 "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_LIBXML2.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_PNG.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_PNG.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_PNG "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_PNG.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_TIFF.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_TIFF.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_TIFF "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_TIFF.*=(.*)E$")

  IF(line MATCHES "^VTK_USE_SYSTEM_ZLIB.*=(.*)E$")
    STRING(REGEX REPLACE "^VTK_USE_SYSTEM_ZLIB.*=(.*)E$" "\\1" AVDN_VTK_USE_SYSTEM_ZLIB "${line}")
  ENDIF(line MATCHES "^VTK_USE_SYSTEM_ZLIB.*=(.*)E$")

 ENDIF(NOT line MATCHES "-ADVANCED:INTERNAL=")
ENDFOREACH(line)


IF(${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} LESS 5.6)
  SET(AVDN_EXTRA_EXCLUDE_CLASSES ${AVDN_EXTRA_EXCLUDE_CLASSES}
    vtkRenderPass
    )
ENDIF()

SET(AVDN_EXTRA_EXCLUDE_CLASSES ${AVDN_EXTRA_EXCLUDE_CLASSES} CACHE STRING
  "Force the wrap_exclude to 1 for these classes")

SET(AVDN_EXTRA_EXCLUDE_CLASSES_XML "")
FOREACH(class ${AVDN_EXTRA_EXCLUDE_CLASSES})
  SET(AVDN_EXTRA_EXCLUDE_CLASSES_XML
    "${AVDN_EXTRA_EXCLUDE_CLASSES_XML}  <Class name=\"${class}\" wrappable=\"false\"/>\n")
ENDFOREACH()
IF(NOT "${AVDN_EXTRA_EXCLUDE_CLASSES_XML}" STREQUAL "")
  SET(AVDN_EXTRA_EXCLUDE_CLASSES_XML "\n  <!-- AVDN_EXTRA_EXCLUDE_CLASSES_XML -->\n${AVDN_EXTRA_EXCLUDE_CLASSES_XML}")
ENDIF()


MESSAGE(STATUS "AVDN_EDITION='${AVDN_EDITION}'")

MESSAGE(STATUS "VTK_DIR='${VTK_DIR}'")
MESSAGE(STATUS "AVDN_VTK_SOURCE_DIR='${AVDN_VTK_SOURCE_DIR}'")

MESSAGE(STATUS "VTK_BUILD_SHARED_LIBS='${VTK_BUILD_SHARED_LIBS}'")
MESSAGE(STATUS "AVDN_VTK_DATA_ROOT='${AVDN_VTK_DATA_ROOT}'")
MESSAGE(STATUS "AVDN_VTK_USE_PARALLEL='${AVDN_VTK_USE_PARALLEL}'")
MESSAGE(STATUS "AVDN_EXTRA_EXCLUDE_CLASSES='${AVDN_EXTRA_EXCLUDE_CLASSES}'")

MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_EXPAT='${AVDN_VTK_USE_SYSTEM_EXPAT}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_FREETYPE='${AVDN_VTK_USE_SYSTEM_FREETYPE}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_JPEG='${AVDN_VTK_USE_SYSTEM_JPEG}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_LIBPROJ4='${AVDN_VTK_USE_SYSTEM_LIBPROJ4}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_LIBXML2='${AVDN_VTK_USE_SYSTEM_LIBXML2}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_PNG='${AVDN_VTK_USE_SYSTEM_PNG}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_TIFF='${AVDN_VTK_USE_SYSTEM_TIFF}'")
MESSAGE(STATUS "AVDN_VTK_USE_SYSTEM_ZLIB='${AVDN_VTK_USE_SYSTEM_ZLIB}'")

MESSAGE(STATUS "csc_EXECUTABLE='${csc_EXECUTABLE}'")
MESSAGE(STATUS "gccxml_EXECUTABLE='${gccxml_EXECUTABLE}'")
MESSAGE(STATUS "mono_EXECUTABLE='${mono_EXECUTABLE}'")
MESSAGE(STATUS "mummy_EXECUTABLE='${mummy_EXECUTABLE}'")


# Set of VTK kits to wrap (caller may set AVDN_KITS)...
# By default, wrap each known kit that has a "vtk${kit}Kit.cmake" file.
#
IF(NOT AVDN_KITS)
  FILE(GLOB ks "${VTK_KITS_DIR}/vtk*Kit.cmake")
  LIST(SORT ks)
  FOREACH(k ${ks})
    STRING(REGEX REPLACE "^.*/vtk(.*)Kit.cmake$" "\\1" kit "${k}")
    IF(EXISTS "${VTK_KITS_DIR}/vtk${kit}Kit.cmake")
      SET(AVDN_KITS ${AVDN_KITS} "${kit}")
    ENDIF(EXISTS "${VTK_KITS_DIR}/vtk${kit}Kit.cmake")
  ENDFOREACH(k)
ENDIF(NOT AVDN_KITS)

SET(kits ${AVDN_KITS})


# Organization:
#
# If MV_ONE_EXPORT_LAYER_DLL is 0 then all the generated export-layer/*.cxx
# files get built into multiple export layer DLLs called ${CMAKE_SHARED_LIBRARY_PREFIX}vtk${kit}EL${CMAKE_SHARED_LIBRARY_SUFFIX}.
# If VTK is built as dlls, we need to use multiple export layer DLLs.
#
# If MV_ONE_EXPORT_LAYER_DLL is 1 then all the generated export-layer/*.cxx
# files get built into one large export layer DLL called ${CMAKE_SHARED_LIBRARY_PREFIX}Kitware.VTK.Unmanaged${CMAKE_SHARED_LIBRARY_SUFFIX}.
# If VTK is built as static libs, we need to use one large export layer DLL.
#
IF(VTK_BUILD_SHARED_LIBS)
  SET(MV_ONE_EXPORT_LAYER_DLL 0)
ELSE(VTK_BUILD_SHARED_LIBS)
  SET(MV_ONE_EXPORT_LAYER_DLL 1)
ENDIF(VTK_BUILD_SHARED_LIBS)


# Read svn info/status prior to configuring version information.
#
INCLUDE("${Mummy_DIR}/SvnMacros.cmake")

SET(AVDN_SOURCE_TREE_IS_SVN_CHECKOUT 0)
IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")
  SET(AVDN_SOURCE_TREE_IS_SVN_CHECKOUT 1)
ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")

# Retrieve current state of the source tree according to svn,
# if this source tree is an svn checkout. Otherwise, status
# is just empty...
#
SET(AVDN_SVN_STATUS "")
IF(AVDN_SOURCE_TREE_IS_SVN_CHECKOUT)
  SVN_STATUS("${CMAKE_CURRENT_SOURCE_DIR}" AVDN_SVN_STATUS)
ENDIF(AVDN_SOURCE_TREE_IS_SVN_CHECKOUT)

IF("${AVDN_SVN_STATUS}" STREQUAL "")
  SET(AVDN_SVN_STATUS_BRIEF "")
  SET(AVDN_SVN_STATUS_ENCODED "")
ELSE("${AVDN_SVN_STATUS}" STREQUAL "")
  SET(AVDN_SVN_STATUS_BRIEF " [warning: experimental development build!]")
  STRING(REGEX REPLACE "\\\\" "/" AVDN_SVN_STATUS_ENCODED "${AVDN_SVN_STATUS}")
  STRING(REGEX REPLACE "\n" "\\\\n" AVDN_SVN_STATUS_ENCODED "${AVDN_SVN_STATUS_ENCODED}")

=== debian/changelog ===
activiz.net (1:1.0~git20111123-6) unstable; urgency=low

  * Installing into the gac.
  * Remove DMUA flag, not required anymore
  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias

 -- Mathieu Malaterre <malat@debian.org>  Sat, 21 Apr 2012 22:39:10 +0200

activiz.net (1:1.0~git20111123-5) unstable; urgency=low

  * discard result from build-indep target from d/rules.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 01 Feb 2012 14:09:16 +0100

activiz.net (1:1.0~git20111123-4) unstable; urgency=medium

  * Work around bbuild and build-indep, by hidding doxygen target.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 31 Jan 2012 17:54:55 +0100

activiz.net (1:1.0~git20111123-3) unstable; urgency=medium

  * Speed up compilation of build-indep target (dot generation)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Sat, 28 Jan 2012 15:32:09 +0100

activiz.net (1:1.0~git20111123-2) unstable; urgency=medium

  * Use debian default csharp compiler. Closes: #655935

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 17 Jan 2012 10:17:22 +0100

activiz.net (1:1.0~git20111123-1) unstable; urgency=low

  [ Thorsten Alteholz ]
  * debian/get-orig-source: put orig.tar.gz in ../tarballs to allow
    automatic build with svn-buildpackage

  [ Mathieu Malaterre ]
  * Fix compilation issue with VTK 5.8.0
  * Automatically computes soversion information from vtk version

  [ Andreas Tille ]
  * debian/copyright: Fixed License paragraphs to match DEP5
  * debian/control: Added myself as uploader

 -- Andreas Tille <tille@debian.org>  Thu, 24 Nov 2011 09:57:56 +0100

activiz.net (5.6.1-3) unstable; urgency=low

  * Need doxygen-latex to pull dvips/latex dependency.
  * Use trick to conditionnaly set GENERATE_DOXYGEN. Closes: #648074

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 10 Nov 2011 22:22:20 +0100

activiz.net (5.6.1-2) unstable; urgency=low

  * Fix issue on buildd machine where doxygen would not be available

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 09 Nov 2011 10:23:06 +0100

activiz.net (5.6.1-1) unstable; urgency=low

  * Initial release (Closes: #611764)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 31 Oct 2011 15:44:31 +0100

=== debian/control ===
Source: activiz.net
Section: graphics
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.3), mummy,
 libkitware-mummy-runtime1.0-cil, gccxml, libvtk5-dev (>= 5.6), mono-devel,
 cli-common-dev (>= 0.8~)
Build-Depends-Indep: doxygen-latex (>= 1.6.2), graphviz
Standards-Version: 3.9.3
Homepage: http://www.kitware.com/products/avdownload.php
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/activiz.net/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/activiz.net/trunk/

Package: libactiviz.net-cil
Provides: libactiviz.net${vtk:Version}-cil
Architecture: any
Section: cli-mono
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}
Description: Tool for generating C# wrappers around VTK
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments. ActiViz, which generates C#
 wrappers around VTK, enables developers to combine the power of VTK with the
 many .NET framework objects for web and database access. Available as source
 code or as a pre-built WinForms Control, ActiViz .NET includes examples, online
 documentation, and supports IntelliSense in the .NET Framework

Package: activiz.net-doc
Architecture: all
Depends: ${misc:Depends}, doc-base
Suggests: vtk-doc
Section: doc
Description: ActiViz.NET documentation
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 .
 This package contains exhaustive HTML documentation for the all the
 documented ActiViz.NET C# classes.

Package: activiz.net-examples
Architecture: all
Suggests: vtk-examples
Depends: ${misc:Depends}
Description: ActiViz.NET examples
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package contains examples from the ActiViz.NET source.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
export LDFLAGS=-Wl,--as-needed

# dpkg-shlibdeps needs to know where is libKitware.mummy.Runtime.Unmanaged.so
export LD_LIBRARY_PATH+=:/usr/lib/cli/Kitware.mummy.Runtime-1.0

# http://vtk.org/Bug/view.php?id=11875
CMAKE_FLAGS = \
	-DAVDN_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DAVDN_SNKEYFILE:STRING=/usr/share/cli-common/keys/mono.snk \
	-Dcsc_EXECUTABLE=/usr/bin/mono-csc \
	-DAVDN_EXTRA_EXCLUDE_CLASSES:STRING="vtkMPIController;vtkMPICommunicator"

# B-D-I is still not quite right on buildd, but anyway let's be prepared:
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  CMAKE_FLAGS += -DGENERATE_DOXYGEN:BOOL=OFF
else
  CMAKE_FLAGS += -DGENERATE_DOXYGEN:BOOL=ON
endif

%:
	dh $@ --parallel --with cli

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

# Let's be smart with building doc
override_dh_auto_build-indep:
	-$(MAKE) -C obj-* AVDN_doxygen

# No tests needed for docs
override_dh_auto_test-indep:

pkg_doc = activiz.net-doc
pkg_exa = activiz.net-examples

override_dh_install-indep:
	dh_install -p$(pkg_doc) obj-*/Doxygen/html usr/share/doc/$(pkg_doc)/
	find ./debian/$(pkg_doc)/usr/share/doc/$(pkg_doc)/html/ -name *.md5 -delete
	#dh_installexamples -p$(pkg_exa) usr/Examples/*
	dh_install -p$(pkg_exa) usr/Examples/*  usr/share/doc/$(pkg_exa)/examples
	find ./debian/$(pkg_exa) -name *.sln -delete

# automatically compute SOVERSION from vtk package:
vtk_version=$(shell apt-cache policy libvtk5-dev | grep "Installed:" | cut -d: -f2 | cut -d' ' -f2 | cut -d- -f1 | cut -d. -f1-2)
override_dh_gencontrol:
	dh_gencontrol -- -Vvtk:Version=$(vtk_version)

get-orig-source:
	./debian/get-orig-source

## activiz.net 1.0~git20111214

=== SuperBuild/CMakeLists.txt ===
##############################################################################
# A SuperBuild for ActiViz .NET and its pre-requisites

cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)
project(ActiVizDotNetSuperBuild NONE)

include(ExternalProject)
include(CTest)


##############################################################################
# ActiViz .NET requires tools, data and libraries.
#
# Tools: (these must be installed before configuring this SuperBuild)
#   cmake 2.8.6 or later
#   python 2.6 or later
#   cvs
#   git
#
#
# The following are all built by this SuperBuild before ActiViz .NET:
#
# Tools:
#   gccxml
#   mummy (depends on gccxml)
#
# Data:
#   VTKData
#
# Libraries:
#   VTK (depends on VTKData)
#
#
# If doxygen is installed, the mummy build will include some doxygen
# generated docs.
#
# Python must be installed in order to configure ActiViz .NET: the test suite
# has some tests that are generated using python scripts.


##############################################################################
# CMAKE_GENERATOR restriction
#
# On Windows, with the 32-bit Visual Studio generators, this SuperBuild
# includes targets for both 32-bit and 64-bit VTK and ActiViz .NET.
#
# The mummy build also includes both 32-bit and 64-bit outputs when
# configured with the 32-bit generators. Therefore, we disallow the Win64
# generators.
#
# gccxml and mummy are built with the chosen CMAKE_GENERATOR. When the
# generator matches "Visual Studio" VTK and ActiViz .NET get targets with
# both "${CMAKE_GENERATOR}" and "${CMAKE_GENERATOR} Win64"...

if(CMAKE_GENERATOR MATCHES "Win64")
  set(msg "Do not use a Win64 generator with the ActiViz .NET SuperBuild.")
  set(msg "${msg} The SuperBuild includes targets for both x86 and x64 when")
  set(msg "${msg} you use the non-Win64 generator...")
  message(FATAL_ERROR "${msg}")
endif()

set(AVSB_build_x64_targets OFF)
if(CMAKE_GENERATOR MATCHES "Visual Studio")
  set(AVSB_build_x64_targets ON)
endif()


##############################################################################
# Versions this SuperBuild references:

set(gccxml_version "2011-11-03 01:00:00 UTC")
set(mummy_version "1.0.2")

set(vtk_version "5.8.0")
if(NOT "$ENV{AVSB_VTK_VERSION}" STREQUAL "")
  set(vtk_version "$ENV{AVSB_VTK_VERSION}")
endif()

set(vtk_git_tag "v${vtk_version}")
if(NOT "$ENV{AVSB_VTK_GIT_TAG}" STREQUAL "")
  set(vtk_git_tag "$ENV{AVSB_VTK_GIT_TAG}")
endif()

set(vtkdata_git_tag "v${vtk_version}-data")
if(NOT "$ENV{AVSB_VTKDATA_GIT_TAG}" STREQUAL "")
  set(vtkdata_git_tag "$ENV{AVSB_VTKDATA_GIT_TAG}")
endif()


##############################################################################
# SuperBuild options:

option(BUILD_SHARED_LIBS "Build pre-requisite libs as shared libraries" ON)
option(AVSB_BUILD_FOR_REDIST "Strong-name sign build products, create installers" ON)
set(AVSB_SNKEYFILE "" CACHE FILEPATH "Strong name signing key")


##############################################################################
# Double checks:

set(avdn_redist_args "")

if(AVSB_BUILD_FOR_REDIST)
  set(avdn_redist_args "-DAVDN_BUILD_CSHARP_DEBUG:BOOL=OFF")

  if(NOT AVSB_SNKEYFILE)
    set(msg "Empty AVSB_SNKEYFILE value, C# dlls will not be correctly")
    set(msg "${msg} strong-name signed...")
    message(AUTHOR_WARNING "${msg}")
      # If this warning is emitted, the mummy and ActiViz .NET test suites
      # will not run correctly on this machine unless strong name validation
      # is disabled...
  endif()
endif()


##############################################################################
# gccxml

ExternalProject_Add(gccxml
  CVS_REPOSITORY ":pserver:anoncvs:@www.gccxml.org:/cvsroot/GCC_XML"
  CVS_MODULE gccxml
  CVS_TAG -D "${gccxml_version}"
  UPDATE_COMMAND "" # update unnecessary, because it's a fixed static tag
  CMAKE_ARGS
    -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR>
)

ExternalProject_Get_Property(gccxml binary_dir)
set(gccxml_binary_dir "${binary_dir}")

ExternalProject_Get_Property(gccxml install_dir)
set(gccxml_dir "${install_dir}")
set(gccxml_exe "${gccxml_dir}/bin/gccxml")

if(WIN32)
  ExternalProject_Add_Step(gccxml gccxml_clean_install
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${gccxml_dir}/bin
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${gccxml_dir}/share
    WORKING_DIRECTORY ${gccxml_dir}
    DEPENDEES build # happens after build...
    DEPENDERS install # ...but before install
  )

  ExternalProject_Add_Step(gccxml gccxml_vcconfig
    COMMAND gccxml_vcconfig.bat
    WORKING_DIRECTORY ${gccxml_dir}/bin
    DEPENDEES install
  )
endif()


##############################################################################
# mummy

set(mummy_keyfile_args "")
if(AVSB_SNKEYFILE)
  set(mummy_keyfile_args "-DMummy_SNKEYFILE:FILEPATH=${AVSB_SNKEYFILE}")
endif()

ExternalProject_Add(mummy
  GIT_REPOSITORY "git://public.kitware.com/mummy.git"
  GIT_TAG "v${mummy_version}"
  UPDATE_COMMAND "" # update unnecessary, because it's a fixed static tag
  CMAKE_ARGS
    -Dgccxml_EXECUTABLE:FILEPATH=${gccxml_exe}
    -DMummy_INSTALL_PREFIX:PATH=<INSTALL_DIR>
    ${mummy_keyfile_args}
  DEPENDS gccxml
)

ExternalProject_Get_Property(mummy binary_dir)
set(mummy_binary_dir "${binary_dir}")

ExternalProject_Get_Property(mummy install_dir)
set(mummy_dir "${install_dir}/share/mummy-${mummy_version}")


##############################################################################
# VTKData

ExternalProject_Add(vtkdata
  GIT_REPOSITORY "git://vtk.org/VTKData.git"
  GIT_TAG "${vtkdata_git_tag}"
  UPDATE_COMMAND "" # update unnecessary, because it's a fixed static tag
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
)

ExternalProject_Get_Property(vtkdata source_dir)
set(vtkdata_dir "${source_dir}")


##############################################################################
# VTK

ExternalProject_Add(vtksource
  GIT_REPOSITORY "git://vtk.org/VTK.git"
  GIT_TAG "${vtk_git_tag}"
  UPDATE_COMMAND "" # update unnecessary, because it's a fixed static tag
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  DEPENDS
    vtkdata
)

ExternalProject_Get_Property(vtksource source_dir)
set(vtksource_dir "${source_dir}")

function(build_vtk suffix generator)
  ExternalProject_Add(vtk${suffix}
    SOURCE_DIR "${vtksource_dir}"
    DOWNLOAD_COMMAND ""
    UPDATE_COMMAND ""
    CMAKE_ARGS
      -DBUILD_SHARED_LIBS:BOOL=${BUILD_SHARED_LIBS}
      -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR>
      -DVTK_DATA_ROOT:PATH=${vtkdata_dir}
      -DVTK_DEBUG_LEAKS:BOOL=OFF
      -DVTK_USE_PARALLEL:BOOL=ON
    CMAKE_GENERATOR ${generator}
    INSTALL_COMMAND ""
    DEPENDS
      vtksource
  )
endfunction()

build_vtk("" "${CMAKE_GENERATOR}")

if(AVSB_build_x64_targets)
  build_vtk("_x64" "${CMAKE_GENERATOR} Win64")
endif()


##############################################################################
# avdn

get_filename_component(dir "${CMAKE_CURRENT_LIST_FILE}" PATH)
get_filename_component(avdn_source_dir "${dir}" PATH)
message(STATUS "avdn_source_dir='${avdn_source_dir}'")

set(avdn_keyfile_args "")
if(AVSB_SNKEYFILE)
  set(avdn_keyfile_args "-DAVDN_SNKEYFILE:FILEPATH=${AVSB_SNKEYFILE}")
endif()

function(build_avdn suffix generator)
  ExternalProject_Get_Property(vtk${suffix} binary_dir)
  set(vtk_dir "${binary_dir}")

  ExternalProject_Add(avdn${suffix}
    DOWNLOAD_COMMAND ""
    UPDATE_COMMAND ""
    SOURCE_DIR "${avdn_source_dir}"
    CMAKE_ARGS
      -DAVDN_INSTALL_PREFIX:PATH=<INSTALL_DIR>
      ${avdn_keyfile_args}
      ${avdn_redist_args}
      -Dgccxml_EXECUTABLE:FILEPATH=${gccxml_exe}
      -DMummy_DIR:PATH=${mummy_dir}
      -DVTK_DIR:PATH=${vtk_dir}
    CMAKE_GENERATOR ${generator}
    INSTALL_COMMAND ""
    DEPENDS
      mummy
      vtk${suffix}
  )
endfunction()

build_avdn("" "${CMAKE_GENERATOR}")

if(AVSB_build_x64_targets)
  build_avdn("_x64" "${CMAKE_GENERATOR} Win64")
endif()


##############################################################################
# Installers

function(build_installer proj)
  ExternalProject_Get_Property(${proj} binary_dir)
  set(proj_dir "${binary_dir}")

  ExternalProject_Add(${proj}-installer
    BINARY_DIR "${proj_dir}"
    DOWNLOAD_COMMAND ""
    UPDATE_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ${CMAKE_COMMAND}
      --build ${proj_dir} --config ${CMAKE_CFG_INTDIR} --target package
    INSTALL_COMMAND ${CMAKE_COMMAND} -E echo
      "The '${proj}' installer is now available in '${proj_dir}'"
    DEPENDS
      ${proj}
  )
endfunction()

build_installer(gccxml)
build_installer(mummy)

build_installer(avdn)

if(AVSB_build_x64_targets)
  build_installer(avdn_x64)
endif()


##############################################################################
# Tests

include(ProcessorCount)
ProcessorCount(num_procs)

function(add_test_suite proj)
  ExternalProject_Get_Property(${proj} binary_dir)
  set(dir "${binary_dir}")

  add_test(NAME ${proj}-tests
    COMMAND ${CMAKE_CTEST_COMMAND} -C $<CONFIGURATION> -j ${num_procs}
      -D ExperimentalTest --output-on-failure
    WORKING_DIRECTORY ${dir}
  )

  # Since we're using all processors to run the target test suite in "full
  # parallel," run this "test" (which is actually a full suite of tests for
  # the named target) by itself:

  set_property(TEST ${proj}-tests PROPERTY RUN_SERIAL ON)
endfunction()

add_test_suite(gccxml)
add_test_suite(mummy)
add_test_suite(vtk)
add_test_suite(avdn)

if(AVSB_build_x64_targets)
  add_test_suite(vtk_x64)
  add_test_suite(avdn_x64)
endif()


##############################################################################
# Log all variable values:

#message(STATUS "========== VARIABLES ==========")
#get_cmake_property(vs VARIABLES)
#foreach(v ${vs})
#  message(STATUS "${v}='${${v}}'")
#endforeach()

=== Testing/CMakeLists.txt ===
SET(EXE_DIR ".")
IF(EXECUTABLE_OUTPUT_PATH)
  SET(EXE_DIR "${EXECUTABLE_OUTPUT_PATH}")
ENDIF(EXECUTABLE_OUTPUT_PATH)

# C# tests:
#
SET(AVDN_CSHARP_TESTS
#  "${CMAKE_CURRENT_SOURCE_DIR}/ExhaustMemoryQuicklyTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/RenderWindowControlTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkActor2DTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkConeSourceTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkImageDataExtraTests.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkObjectModifiedEvtTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkObjectTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkPointsTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkProgrammableAttributeDataFilterTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVersionTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkViewSelectionChangedEvtTest.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkWin32OpenGLRenderWindowTest.cs"
)

IF(WIN32)
  SET(AVDN_CSHARP_TESTS ${AVDN_CSHARP_TESTS}
    "${CMAKE_CURRENT_SOURCE_DIR}/vtkCommandTest.cs"
    "${CMAKE_CURRENT_SOURCE_DIR}/vtkImplicitFunctionSubclassTest.cs"
  )
ENDIF()

CONFIGURE_FILE(
  "${Mummy_DIR}/CSharpTestDriver.cs.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CSharpTestDriver.cs"
  @ONLY
)

SET(AVDN_TEST_CSC_REFS "Kitware.VTK;Kitware.mummy.Runtime")

IF(NOT WIN32)
  #
  # The mono C# compiler does not appear to add these common refs by default
  # like the MS C# compiler does... add them explicitly:
  #
  SET(AVDN_TEST_CSC_REFS ${AVDN_TEST_CSC_REFS}
    "System.Drawing"
    "System.Data"
    "System.Windows.Forms"
    )
ENDIF(NOT WIN32)

ADD_CSHARP_EXECUTABLE(
  "Kitware.VTK.CSharpTests"
  "Kitware.VTK"
  "${AVDN_TEST_CSC_REFS}"
  ""
  ""
  # Source files:
  "${CMAKE_CURRENT_BINARY_DIR}/CSharpTestDriver.cs"
  ${AVDN_CSHARP_TESTS}
)

# C++ tests:
#
SET(AVDN_CXX_TESTS
  "IntentionallyUninitializedData.cxx"
)

# CMake generated cxx test driver uses strcpy and scanf.
# Disable the warnings about them from the MS compiler:
#
#ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_DEPRECATE)
ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
#ADD_DEFINITIONS(-D_SCL_SECURE_NO_DEPRECATE)

CREATE_TEST_SOURCELIST(AVDN_CXX_TESTS_SOURCELIST
  Kitware.VTK.CxxTests.cxx
  ${AVDN_CXX_TESTS}
)

ADD_EXECUTABLE(
  "Kitware.VTK.CxxTests"
  ${AVDN_CXX_TESTS_SOURCELIST}
)

TARGET_LINK_LIBRARIES("Kitware.VTK.CxxTests"
  vtkViews
  vtkVolumeRendering
)

# Each C# test listed above:
#
FOREACH(test ${AVDN_CSHARP_TESTS})
  GET_FILENAME_COMPONENT(name "${test}" NAME)
  GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
  ADD_CSHARP_TEST(${name}
    ${EXE_DIR}/Kitware.VTK.CSharpTests.exe ${name_we}
    -D ${AVDN_VTK_DATA_ROOT}
  )
  SET_TESTS_PROPERTIES(${name} PROPERTIES
    FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
  )
ENDFOREACH(test)

# Each C++ test listed above, executed with no arguments:
#
FOREACH(test ${AVDN_CXX_TESTS})
  GET_FILENAME_COMPONENT(name "${test}" NAME)
  GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
  ADD_TEST(${name}
    ${EXE_DIR}/Kitware.VTK.CxxTests ${name_we}
  )
  SET_TESTS_PROPERTIES(${name} PROPERTIES
    FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
  )
ENDFOREACH(test)

# The "PrintAll" test. Execute vtkObjectTest with a list of
# classnames to instantiate and print...
#
SET(allclasses_file "${CMAKE_CURRENT_BINARY_DIR}/PrintAllTestInput.txt")
FILE(WRITE "${allclasses_file}" "")

SET(table ${WRAPPED_CLASS_TABLE})
FOREACH(entry ${table})
  # each 'entry' looks like: "${cxxclass} ${kit} ${abstract} ${header}"
  STRING(REGEX REPLACE "^([^ ]+) ([^ ]+) ([^ ]+) (.*)$" "\\1" cxxclass "${entry}")

  # The exclusions presently cause this test to crash or fail...
  # Fix VTK and then remove these exclusions:
  #
  IF(NOT cxxclass MATCHES "^(vtkImageViewer2|vtkInteractorStyleTrackball|vtkObjectBase|vtkOrientedPolygonalHandleRepresentation3D|vtkPolygonalHandleRepresentation3D|vtkStructuredPointsGeometryFilter|vtkTreeMapViewer)$")
    FILE(APPEND "${allclasses_file}" "${cxxclass}\n")
  ENDIF(NOT cxxclass MATCHES "^(vtkImageViewer2|vtkInteractorStyleTrackball|vtkObjectBase|vtkOrientedPolygonalHandleRepresentation3D|vtkPolygonalHandleRepresentation3D|vtkStructuredPointsGeometryFilter|vtkTreeMapViewer)$")
ENDFOREACH(entry)

ADD_CSHARP_TEST(PrintAll
  ${EXE_DIR}/Kitware.VTK.CSharpTests.exe vtkObjectTest --classnames-file "${allclasses_file}"
)
SET_TESTS_PROPERTIES(PrintAll PROPERTIES
  FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
)

# Special properties for some tests:
#
#SET_TESTS_PROPERTIES(ExhaustMemoryQuicklyTest.cs PROPERTIES
#  WILL_FAIL 1
#)

# Converted tcl tests:
#
ADD_SUBDIRECTORY(TclToCsScript)

=== Testing/TclToCsScript/CMakeLists.txt ===
# See if AVDN_VTK_SOURCE_DIR is available... if not we are out of luck.
# We need AVDN_VTK_SOURCE_DIR to be able to convert the list of tcl tests.
#
IF(NOT AVDN_VTK_SOURCE_DIR)
  MESSAGE(FATAL_ERROR "required variable AVDN_VTK_SOURCE_DIR is not set...")
ENDIF(NOT AVDN_VTK_SOURCE_DIR)

FIND_PROGRAM(PYTHON_EXE "python")
IF(NOT PYTHON_EXE)
  MESSAGE(FATAL_ERROR "python required to convert tcl tests")
ENDIF(NOT PYTHON_EXE)


# Copy-if-necessary *.py from current source dir to current binary dir. Run
# all python scripts in the binary dir so we can do two or more builds at
# once. When we used to generate *.py scripts in the source tree, multiple
# simultaneous builds would occasionally clobber each other's changes to the
# source tree... Also copy over any files that the python scripts expect to
# be in the "current working directory" when they are run.
foreach(py_file
  GenerateVtkColors.py
  GenerateVtkCommandList.py
  recursiveglob.py
  refdouble.hints
  TclToCsConvertorDriver.py
  TclToCsHashMap.py
  XML_Parser.py
  vtkTclParser.py
  vtkTclToCsConvertor.py
)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${py_file}
    ${CMAKE_CURRENT_BINARY_DIR}/${py_file}
    COPYONLY
  )
endforeach()

# vtkClassList.py
FILE(WRITE "${CMAKE_CURRENT_BINARY_DIR}/vtkClassList.py.in" "VTKClassList = [\n\"___list_begins___\",\n")
FOREACH(entry ${WRAPPED_CLASS_TABLE})
  STRING(REGEX REPLACE "^([^ ]+) .*$" "\\1" cxxclass "${entry}")
    # each 'entry' looks like: "${cxxclass} ${kit} ${abstract} ${header}"
  FILE(APPEND "${CMAKE_CURRENT_BINARY_DIR}/vtkClassList.py.in" "\"${cxxclass}\",\n")
ENDFOREACH(entry)
FILE(APPEND "${CMAKE_CURRENT_BINARY_DIR}/vtkClassList.py.in" "\"__list_ends__\"\n]\n\ndef get_vtk_classes():\n  return VTKClassList\n")
configure_file(
  ${CMAKE_CURRENT_BINARY_DIR}/vtkClassList.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkClassList.py
  COPYONLY
)

# Generate the list of vtkColors
MESSAGE(STATUS "Generating vtkColors.py.in / vtkColors.py")
EXECUTE_PROCESS (COMMAND ${PYTHON_EXE} GenerateVtkColors.py
  -vtkdir ${AVDN_VTK_SOURCE_DIR}
  RESULT_VARIABLE RES_VAR
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
configure_file(
  ${CMAKE_CURRENT_BINARY_DIR}/vtkColors.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkColors.py
  COPYONLY
)

# Generate the list of vtkCommands
MESSAGE(STATUS "Generating vtkCommandList.py.in / vtkCommandList.py")
EXECUTE_PROCESS (COMMAND ${PYTHON_EXE} GenerateVtkCommandList.py
  -vtkdir ${AVDN_VTK_SOURCE_DIR}
  RESULT_VARIABLE RES_VAR
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
configure_file(
  ${CMAKE_CURRENT_BINARY_DIR}/vtkCommandList.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkCommandList.py
  COPYONLY
)


MACRO(CONVERT_VTK_TCL_SCRIPT_TO_CSHARP cvtstc_file cvtstc_listvar)
  GET_FILENAME_COMPONENT(cvtstc_name_we "${cvtstc_file}" NAME_WE)

  ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/AV${cvtstc_name_we}.cs
    COMMAND ${PYTHON_EXE}
    ARGS
      ${CMAKE_CURRENT_BINARY_DIR}/vtkTclToCsConvertor.py
      -i "${cvtstc_file}"
      -o "${CMAKE_CURRENT_BINARY_DIR}/AV${cvtstc_name_we}.cs"
      -xmldir "${ActiVizDotNet_BINARY_DIR}/xml"
    DEPENDS
      "${cvtstc_file}"
      ${CMAKE_CURRENT_BINARY_DIR}/vtkTclToCsConvertor.py
  )

  SET(${cvtstc_listvar} ${${cvtstc_listvar}} "${CMAKE_CURRENT_BINARY_DIR}/AV${cvtstc_name_we}.cs")
ENDMACRO(CONVERT_VTK_TCL_SCRIPT_TO_CSHARP)


# Initialize lists (one per kit plus one catchall named "Other"):
#
SET(kits ${AVDN_KITS})

SET(Other_outputlist "")
FOREACH(kit ${kits})
  SET(${kit}_outputlist "")
ENDFOREACH(kit)




FILE(READ "Currently_Compiling_Tests.txt" testlist)
STRING(REGEX REPLACE ";" "\\\\;" testlist "${testlist}")
STRING(REGEX REPLACE "\n" "E;" testlist "${testlist}")

FOREACH(t ${testlist})
  IF("${t}" MATCHES "^(.*.tcl).*E$")
  IF(NOT "${t}" MATCHES "^#")
    STRING(REGEX REPLACE "^(.*.tcl).*E$" "\\1" tclfile "${t}")

    IF("${AVDN_VTK_SOURCE_DIR}/${tclfile}" MATCHES "^.*/([^/]+)/Testing/Tcl/.*$")
      STRING(REGEX REPLACE "^.*/([^/]+)/Testing/Tcl/.*$" "\\1" kit "${AVDN_VTK_SOURCE_DIR}/${tclfile}")
    ELSE()
      SET(kit "Other")
    ENDIF()

    #MESSAGE(STATUS "kit='${kit}' t='${t}'")

    CONVERT_VTK_TCL_SCRIPT_TO_CSHARP("${AVDN_VTK_SOURCE_DIR}/${tclfile}" ${kit}_outputlist)
  ENDIF(NOT "${t}" MATCHES "^#")
  ENDIF("${t}" MATCHES "^(.*.tcl).*E$")
ENDFOREACH(t)


# Custom targets to organize things in the VS .sln file and to ensure
# that Kitware.VTK builds before these targets. (So that all the xml
# files from all the gccxml steps are guaranteed to be there before
# running the python script to convert a test, which may require an
# arbitrary set of the xml files to process any given test...)
#
ADD_CUSTOM_TARGET(
  "ConvertTcl-Other" ALL
  DEPENDS ${Other_outputlist}
)
ADD_DEPENDENCIES("ConvertTcl-Other" Kitware.VTK)

FOREACH(kit ${kits})
  ADD_CUSTOM_TARGET(
    "ConvertTcl-${kit}Tests" ALL
    DEPENDS ${${kit}_outputlist}
  )
  ADD_DEPENDENCIES("ConvertTcl-${kit}Tests" Kitware.VTK)
ENDFOREACH(kit)


SET(AVDN_CONVERTED_TCL_TESTS ${Other_outputlist})
FOREACH(kit ${kits})
  SET(AVDN_CONVERTED_TCL_TESTS ${AVDN_CONVERTED_TCL_TESTS} ${${kit}_outputlist})
ENDFOREACH(kit)

ADD_CSHARP_EXECUTABLE(
  "Kitware.VTK.ConvertedTclTests"
  "Kitware.VTK"
  "Kitware.VTK;Kitware.mummy.Runtime"
  ""
  ""
  "${CMAKE_CURRENT_SOURCE_DIR}/CSharpTestDriver.cs"
  ${AVDN_CONVERTED_TCL_TESTS}
)

# Ensure Kitware.VTK.ConvertedTclTests builds *after* all the
# "ConvertTcl-*" projects. Otherwise, it tries to build the
# custom command steps in parallel with the ConvertTcl projects
# and some end up building twice because of this...
#
ADD_DEPENDENCIES("Kitware.VTK.ConvertedTclTests" "ConvertTcl-Other")
FOREACH(kit ${kits})
  ADD_DEPENDENCIES("Kitware.VTK.ConvertedTclTests" "ConvertTcl-${kit}Tests")
ENDFOREACH(kit)

# Tell test driver whether or not to do the image regression
SET(fail_on_image_diff_flag "--fail-on-image-diff")

FOREACH(kit ${kits})
  FOREACH(test ${${kit}_outputlist})
    GET_FILENAME_COMPONENT(name "${test}" NAME)
    GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
    STRING(REGEX REPLACE "^AV(.*)$" "\\1" pngname "${name_we}")
    ADD_CSHARP_TEST(${name}
      ${EXE_DIR}/Kitware.VTK.ConvertedTclTests.exe ${name_we}
      -D ${AVDN_VTK_DATA_ROOT}
      -T ${CMAKE_BINARY_DIR}/Testing/Temporary
      -V Baseline/${kit}/${pngname}.png
      ${fail_on_image_diff_flag}
    )
    SET_TESTS_PROPERTIES(${name} PROPERTIES
      FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
    )
  ENDFOREACH(test)
ENDFOREACH(kit)


FILE(GLOB_RECURSE HAND_CONVERTED_TESTS "Convert By Hand/*.cs")

#Remove Parallel test if Parallel is not built
FOREACH(test ${HAND_CONVERTED_TESTS})
  GET_FILENAME_COMPONENT(path1 "${test}" PATH)
  GET_FILENAME_COMPONENT(dir "${path1}" NAME)
  IF(${dir} STREQUAL "Parallel")
    IF(NOT AVDN_VTK_USE_PARALLEL)
      LIST(REMOVE_ITEM HAND_CONVERTED_TESTS ${test})
    ENDIF(NOT AVDN_VTK_USE_PARALLEL)
  ENDIF(${dir} STREQUAL "Parallel")
ENDFOREACH(test ${HAND_CONVERTED_TESTS})

#classes that use parallel classes but are not in the parallel folder
IF(NOT AVDN_VTK_USE_PARALLEL)
  LIST(REMOVE_ITEM HAND_CONVERTED_TESTS "${CMAKE_CURRENT_SOURCE_DIR}/Convert By Hand/Graphics/AVStreamPolyData.cs")
ENDIF(NOT AVDN_VTK_USE_PARALLEL)

#IF(AVDN_VTK_USE_PARALLEL)
  #only use GLOB_RECURSE if parallel is turned on

  #ELSE(AVDN_VTK_USE_PARALLEL)
  #don't include subdirs if parallel is off
  # FILE(GLOB HAND_CONVERTED_TESTS "Convert By Hand/*.cs")
  #ENDIF(AVDN_VTK_USE_PARALLEL)

ADD_CSHARP_EXECUTABLE(
  "Kitware.VTK.ConvertedByHandTclTests"
  "Kitware.VTK"
  "Kitware.VTK;Kitware.mummy.Runtime"
  ""
  ""
  "${CMAKE_CURRENT_SOURCE_DIR}/CSharpTestDriver.cs"
  ${HAND_CONVERTED_TESTS}
)

FOREACH(test ${HAND_CONVERTED_TESTS})
  GET_FILENAME_COMPONENT(path "${test}" PATH)
  GET_FILENAME_COMPONENT(dir "${path}" NAME)
  GET_FILENAME_COMPONENT(name "${test}" NAME)
  GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
  STRING(REGEX REPLACE "^AV(.*)$" "\\1" pngname "${name_we}")
  ADD_CSHARP_TEST(${name}
    ${EXE_DIR}/Kitware.VTK.ConvertedByHandTclTests.exe ${name_we}
    -D ${AVDN_VTK_DATA_ROOT}
    -T ${CMAKE_BINARY_DIR}/Testing/Temporary
    -V Baseline/${dir}/${pngname}.png
    ${fail_on_image_diff_flag}
  )
  SET_TESTS_PROPERTIES(${name} PROPERTIES
    FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
  )
ENDFOREACH(test)

#FOREACH(test ${AVDN_CONVERTED_TCL_TESTS})
#  GET_FILENAME_COMPONENT(name "${test}" NAME)
#  GET_FILENAME_COMPONENT(name_we "${test}" NAME_WE)
#  STRING(REGEX REPLACE "^AV(.*)$" "\\1" pngname "${name_we}")
#  ADD_CSHARP_TEST(${name}
#    ${EXE_DIR}/Kitware.VTK.ConvertedTclTests.exe ${name_we}
#  )
#  SET_TESTS_PROPERTIES(${name} PROPERTIES
#    FAIL_REGULAR_EXPRESSION "(ERROR|Warning): In"
#  )
#ENDFOREACH(test)

=== debian/changelog ===
activiz.net (1:1.0~git20111214-3build1) wily; urgency=medium

  * No-change rebuild against libvtk5.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 26 Sep 2015 07:34:20 +0200

activiz.net (1:1.0~git20111214-3) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Remove Mathieu Malaterre from Uploaders as requested
  * Add Corentin Desfarges to Uploaders as requested
  * Moved from SVN to Git
  * cme fix dpkg-control
  * debian/get-orig-source: use xz compressed tarball
  * debian/watch: Document why there is no proper watch file

  [ Mathieu Malaterre ]
  * debian/patches/vtk5_10_1.patch: fix compilation against vtk5.10
    (Closes: #798545)

 -- Andreas Tille <tille@debian.org>  Wed, 08 Jul 2015 15:49:50 +0200

activiz.net (1:1.0~git20111214-2) unstable; urgency=low

  * Add missing .doc-base file. Closes: #703333
  * Remove .dot file from doc package
  * Do not compress .map file from HTML files

 -- Mathieu Malaterre <malat@debian.org>  Mon, 01 Apr 2013 09:32:09 +0200

activiz.net (1:1.0~git20111214-1) unstable; urgency=low

  * New upstream
  * Bump Std-Vers to 3.9.4, no changes needed
  * Use dh(9), get hardening for free
  * Update patches (use DEP3)
  * Remove SONAME from C# gluelib. Closes: #673966

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Mar 2013 15:06:20 +0100

=== debian/control ===
Source: activiz.net
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Corentin Desfarges <corentin.desfarges.dev@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake (>= 2.8.3),
               mummy,
               libkitware-mummy-runtime1.0-cil,
               gccxml,
               libvtk5-dev (>= 5.6),
               mono-devel,
               cli-common-dev (>= 0.8~)
Build-Depends-Indep: doxygen-latex,
                     graphviz
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/activiz.net.git
Vcs-Git: git://anonscm.debian.org/debian-med/activiz.net.git
Homepage: http://www.kitware.com/products/avdownload.php

Package: libactiviz.net-cil
Architecture: any
Section: cli-mono
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${cli:Depends}
Provides: libactiviz.net${vtk:Version}-cil
Description: Tool for generating C# wrappers around VTK
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments. ActiViz, which generates C#
 wrappers around VTK, enables developers to combine the power of VTK with the
 many .NET framework objects for web and database access. Available as source
 code or as a pre-built WinForms Control, ActiViz .NET includes examples, online
 documentation, and supports IntelliSense in the .NET Framework

Package: activiz.net-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         doc-base
Suggests: vtk-doc
Description: ActiViz.NET documentation
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 .
 This package contains exhaustive HTML documentation for the all the
 documented ActiViz.NET C# classes.

Package: activiz.net-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: vtk-examples
Description: ActiViz.NET examples
 ActiViz provides a powerful interface to the Visualization Toolkit (VTK), an
 object-oriented software system encompassing thousands of algorithms that
 transform data into interactive 3D environments.
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package contains examples from the ActiViz.NET source.

=== debian/watch ===
# Upstream only provides a Git repository but no tarball
# This no watch file is possible
